<template>
   <div class="recherche-addresse">
     <vue-bootstrap-typeahead ref="cityAutocomplete"
      :data="addresses"
      v-model="addressSearch"
      size="sm"
      :serializer="s => s.properties.label"
      placeholder="Entrez une adresse"
      @hit="selectAddresse($event)"
      >
      <template slot="append">
        <button @click="clear()" class="btn btn-outline-primary" v-if="showClear">
        X
        </button>
      </template>
    </vue-bootstrap-typeahead>
    <div style="display: none;">
      <div id="marker" title="Marker"></div>
    </div>
   </div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable prefer-const */
/* eslint-disable @typescript-eslint/no-this-alias */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Component from 'vue-class-component';
import PluginComponent from '@/components/plugins/PluginComponent';
import axios, { AxiosResponse } from 'axios';
import { Subject } from 'rxjs';
import { debounceTime } from 'rxjs/operators';
import VueBootstrapTypeahead from '../shared/autocomplete/VueBootstrapTypeahead.vue';

// eslint-disable-next-line no-use-before-define
@Component<ApiAdressePlugin>({
  props: {
  },
  watch: {
    addressSearch() {
      this.addressSearchWatch();
    },
  },
  components: {
    VueBootstrapTypeahead,
  },
})
export default class ApiAdressePlugin extends PluginComponent {
  addresses= [];

  addressSearch= '';

  selectedAddress:any= null;

  addressTextChange = new Subject<string>();

  showClear = false;

  marker:any = null;

  mounted() {
    this.addressTextChange.pipe(debounceTime(200)).subscribe((res) => this.getAddresses(res));
  }

  clear() :void {
    this.showClear = false;
    let auto:any = this.$refs.cityAutocomplete;
    auto.inputValue = '';
    this.addressSearch = '';
    this.addresses = [];
    this.marker.setPosition([0, 0]);
  }

  selectAddresse(event:any) {
    console.log(event);
    this.selectedAddress = event;
    if (this.selectedAddress !== null && this.selectedAddress.geometry) {
      let zoomlevel = 14;
      let { type } = this.selectedAddress.properties;
      if (type === 'housenumber') {
        zoomlevel = 19;
      } else if (type === 'street') {
        zoomlevel = 16;
      } else if (type === 'locality') {
        zoomlevel = 16;
      } else if (type === 'municipality') {
        zoomlevel = 14;
      }
      this.showClear = true;
      // On fait le zoom
      this.getMapService().zoomTo(this.selectedAddress.geometry.coordinates, zoomlevel);
      // On ajoute un point pour localiser la ville
      this.marker = this.getMapService().addOverlay(this.selectedAddress.geometry.coordinates);
    }
  }

  getAddresses(query:string) {
    let self = this;
    console.log('get addresses');
    const limit = this.plugin.getParameterValue('result-count');
    axios.get(`https://api-adresse.data.gouv.fr/search/?q=${query}&limit=${limit}`)
      .then((retour) => {
        self.addresses = retour.data.features;
      });
  }

  addressSearchWatch() {
    this.addressTextChange.next(this.addressSearch);
  }
}
</script>

<style scoped lang="less">
.recherche-addresse{
  background-color: transparent;
  pointer-events: auto;
  opacity: 0.7;
}

#marker {
    width: 20px;
    height: 20px;
    border: 1px solid rgb(136, 66, 0);
    border-radius: 10px;
    background-color: rgb(201, 114, 15);
    opacity: 0.7;
}
</style>
